package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.UserCommissionRoleService;
import com.gxwebsoft.shop.entity.UserCommissionRole;
import com.gxwebsoft.shop.param.UserCommissionRoleParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;

/**
 * 用户绑定分红角色控制器
 *
 * @author 科技小王子
 * @since 2024-12-02 12:43:40
 */
@Api(tags = "用户绑定分红角色管理")
@RestController
@RequestMapping("/api/shop/user-commission-role")
public class UserCommissionRoleController extends BaseController {
    @Resource
    private UserCommissionRoleService userCommissionRoleService;

    @ApiOperation("分页查询用户绑定分红角色")
    @GetMapping("/page")
    public ApiResult<PageResult<UserCommissionRole>> page(UserCommissionRoleParam param) {
        // 使用关联查询
        return success(userCommissionRoleService.pageRel(param));
    }

    @ApiOperation("查询全部用户绑定分红角色")
    @GetMapping()
    public ApiResult<List<UserCommissionRole>> list(UserCommissionRoleParam param) {
        // 使用关联查询
        return success(userCommissionRoleService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userCommissionRole:list')")
    @ApiOperation("根据id查询用户绑定分红角色")
    @GetMapping("/{id}")
    public ApiResult<UserCommissionRole> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(userCommissionRoleService.getByIdRel(id));
    }

    @ApiOperation("添加用户绑定分红角色")
    @PostMapping()
    public ApiResult<?> save(@RequestBody UserCommissionRole userCommissionRole) {

        if (userCommissionRoleService.save(userCommissionRole)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改用户绑定分红角色")
    @PutMapping()
    public ApiResult<?> update(@RequestBody UserCommissionRole userCommissionRole) {
        if (userCommissionRoleService.updateById(userCommissionRole)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除用户绑定分红角色")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (userCommissionRoleService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加用户绑定分红角色")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<UserCommissionRole> list) {
        userCommissionRoleService.removeByMap(new HashMap<>() {{
            put("user_id", list.get(0).getUserId());
        }});
        if (userCommissionRoleService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改用户绑定分红角色")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<UserCommissionRole> batchParam) {
        if (batchParam.update(userCommissionRoleService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除用户绑定分红角色")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (userCommissionRoleService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
